/*
 * config.h : General configuration.
 */

#ifndef _CONFIG_H
#define _CONFIG_H

#define __need_size_t

#ifdef DEBUG
#define dprint(x) serial_print(x)
#else
#define dprint(x) do { } while (0)
#endif

#define mb() __asm("":::"memory");
#define unlikely(x) __builtin_expect(!!(x),0)

#define LED_PORT GPIOD
#define LED_PINS (GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15)
#define GREEN_ON   do { mb(); GPIOD->BSRRL = GPIO_Pin_12; mb(); } while (0)
#define GREEN_OFF  do { mb(); GPIOD->BSRRH = GPIO_Pin_12; mb(); } while (0)
#define ORANGE_ON  do { mb(); GPIOD->BSRRL = GPIO_Pin_13; mb(); } while (0)
#define ORANGE_OFF do { mb(); GPIOD->BSRRH = GPIO_Pin_13; mb(); } while (0)
#define RED_ON     do { mb(); GPIOD->BSRRL = GPIO_Pin_14; mb(); } while (0)
#define RED_OFF    do { mb(); GPIOD->BSRRH = GPIO_Pin_14; mb(); } while (0)
#define BLUE_ON    do { mb(); GPIOD->BSRRL = GPIO_Pin_15; mb(); } while (0)
#define BLUE_OFF   do { mb(); GPIOD->BSRRH = GPIO_Pin_15; mb(); } while (0)

#define time_after(a,b)	((long)((b) - (a)) < 0)
#define time_before(a,b) time_after(b,a)
#define time_after_eq(a,b) ((long)((a) - (b)) >= 0)
#define time_before_eq(a,b) time_after_eq(b,a)

#endif
